info/urls.py
from django.urls import path

from . import views

app_name = 'info'
urlpatterns = [
    path("", views.IndexView.as_view(), name="index"),
    path("<int:pk>/", views.DetailView.as_view(), name="detail"),
    path("<int:pk>/results/", views.ResultsView.as_view(), name="results"),
    path("<int:question_id>/answer/", views.answer_list, name="answer_list"),
]

mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('info/', include('info.urls')),
]

info/models.py
import datetime

from django.db import models
from django.utils import timezone
from django.contrib import admin


class Question(models.Model):
    question_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField("date published")

    @admin.display(
        boolean=True,
        ordering='pub_date',
        description='Asked recently?',
    )
    def was_asked_recently(self):
        now = timezone.now()
        return now - datetime.timedelta(days=1) <= self.pub_date <= now

    def __str__(self):
        return self.question_text


class Answer(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    answer_text = models.CharField(max_length=200)

    def __str__(self):
        return self.answer_text

info/views.py
from django.shortcuts import get_object_or_404, render
from django.http import HttpResponse, HttpResponseRedirect
from django.urls import reverse
from django.views import generic
from django.utils import timezone

from .models import Question, Answer


class IndexView(generic.ListView):
    template_name = "info/index.html"
    context_object_name = "latest_question_list"

    def get_queryset(self):
        """
        Return last five asked questions which are published(not including
        those which are set to be asked in the future).
        """
        return Question.objects.filter(
            pub_date__lte=timezone.now()
        ).order_by("-pub_date")[:5]


class DetailView(generic.DetailView):
    model = Question
    template_name = "info/detail.html"

    def get_queryset(self):
        """
        Excludes all questions that will be published in future
        """
        return Question.objects.filter(pub_date__lte=timezone.now())


class ResultsView(generic.DetailView):
    model = Question
    template_name = "info/results.html"


def answer_list(request, question_id):
    question = get_object_or_404(Question, pk=question_id)
    try:
        selected_answer = request.POST["question_answer"]
        if not selected_answer:
            raise KeyError("No input")
    except (KeyError, Answer.DoesNotExist):
        # Redisplay the question answer form
        return render(request, "info/detail.html", {
            "question": question,
            "error_message": "You didn't give the answer.",
        })
    else:
        selected_question = Question.objects.get(pk=question.id)
        selected_question.answer_set.create(answer_text=selected_answer)
        return HttpResponseRedirect(reverse('info:results', args=(question.id,)))

info/templates/info/detail.html
{% load static %}

<link rel="stylesheet" type="text/css" href="{% static 'info/style.css' %}">
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
      integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

<div class="container">
    <div class="row mt-3 col-md-4">
        <form action="{% url 'info:answer_list' question.id %}" method="post">
        {% csrf_token %}
            <fieldset>
                <legend><h1>{{ question.question_text }}</h1></legend>
                {% if error_message %}
                <p style="color:red;"><strong>{{ error_message }}</strong></p>
                {% endif %}
                <input  class="form-control" type="text" name="question_answer" value="">
            </fieldset>
            <input class="btn btn-success mt-2" type="submit" value="Submit">
        </form>
    </div>
</div>

info/templates/info/index.html
{% load static %}

<link rel="stylesheet" type="text/css" href="{% static 'info/style.css' %}">
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
      integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

<div class="container">
    <div class="row mt-3">
        {% if latest_question_list %}
            <ul style="list-style-type:none;">
                {% for question in latest_question_list %}
                <li><a style="text-decoration: none;" href="{% url 'info:detail' question.id %}">{{ question.question_text }}</a></li>
                {% endfor %}
            </ul>
        {% else %}
            <p> No questions are available. </p>
        {% endif %}
    </div>
</div>

info/templates/info/results.html
{% load static %}

<link rel="stylesheet" type="text/css" href="{% static 'info/style.css' %}">
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
      integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

<div class="container">
    <div class="row mt-3">
        <h1>{{ question.question_text }}</h1>
        <ul>
        {% for answer in question.answer_set.all %}
            <li class="ms-3">{{ answer.answer_text }}</li>
        {% endfor %}
        </ul>
        <div class="d-flex">
            <a class="btn btn-primary me-2" style="text-decoration: none;" href="{% url 'info:detail' question.id %}">Answer again?</a>
            <a class="btn btn-info me-2" style="text-decoration: none;" href="{% url 'info:index' %}">Back to home page</a>
        </div>
    </div>
</div>

<!--<h1>{{ question.question_text }}</h1>-->
<!--<ul>-->
<!--{% for answer in question.answer_set.all %}-->
<!--    <li>{{ answer.answer_text }}</li>-->
<!--{% endfor %}-->
<!--</ul>-->

<!--<a href="{% url 'info:detail' question.id %}">Answer again?</a>-->
<!--<a href="{% url 'info:index' %}">Back to home page</a>-->